package cn.citycraft.RealBackpacks.util;

import java.util.ArrayList;
import java.util.List;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.configuration.InvalidConfigurationException;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;

import cn.citycraft.PluginHelper.config.FileConfig;

// import cn.citycraft.RealBackpacks.json.JSONArray;
// import cn.citycraft.RealBackpacks.json.JSONException;
// import cn.citycraft.RealBackpacks.json.JSONObject;

/**
 * Fancy JSON serialization mostly by evilmidget38.
 *
 * @author evilmidget38, gomeow
 *
 */
public class Serialization {
	public static String INVKEY = "Inventory";
	public static String ITEMKEY = "Item";

	public static String listToString(final List<String> list) {
		final FileConfig yml = new FileConfig();
		yml.set(INVKEY, list);
		return yml.saveToString();
	}

	public static List<String> stringToList(final String invString) {
		final FileConfig yml = new FileConfig();
		return yml.getStringList(INVKEY);
	}

	public static Inventory toInventory(final String invString, final String name, final int size) throws InvalidConfigurationException {
		final List<String> itemlist = stringToList(invString);
		final ItemStack[] items = new ItemStack[itemlist.size()];
		for (int i = 0; i < items.length; i++) {
			final FileConfig yml = new FileConfig();
			yml.loadFromString(itemlist.get(i));
			items[i] = yml.getItemStack(ITEMKEY + i);
		}
		final Inventory inv = Bukkit.createInventory(null, size, ChatColor.translateAlternateColorCodes('&', name));
		inv.setContents(items);
		return inv;
	}

	public static List<String> toList(final Inventory inv) {
		final List<String> invlist = new ArrayList<String>();
		for (int i = 0; i < inv.getContents().length; i++) {
			final FileConfig yml = new FileConfig();
			yml.set(ITEMKEY + i, inv.getContents()[i]);
			invlist.add(yml.saveToString());
		}
		return invlist;
	}

	public static String toString(final Inventory inv) {
		return listToString(toList(inv));
	}
}
